/*----------------------------------------------------------------------*/
/* url.c: Locate and print the current netscape URL                     */
/*    see:  http://bach.ece.jhu.edu/~tim/programs/			*/
/*									*/
/* Written: 10/18/99  Tim Edwards					*/
/*  		<tim@stravinsky.jhuapl.edu>  JHU-APL			*/
/* Modified: 03/01/00 Richard Mitchell					*/
/*		<mitchell@osb1.wff.nasa.gov> WFF/NASA 			*/
/*                                                                      */
/* compile with:  cc url.c -o url -L/usr/X11R6/lib -lXt -lXext -lX11    */
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xproto.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

/*------------------------------------------------------------------------*/

Window query_window(Display *dpy, Window root)
{
   Window root_ret, parent, swin;
   Window *children;
   int num_children, i, ret;
   char *wname;

   XQueryTree(dpy, root, &root_ret, &parent, &children, &num_children);

   for (i = 0; i < num_children; i++)
      if (XFetchName(dpy, *(children + i), &wname))
         if ( strncmp(wname, "Netscape: Print", 15)==0
		&& strstr(wname, "Netscape:") != NULL)
            return *(children + i);

   for (i = 0; i < num_children; i++)
      if ((swin = query_window(dpy, *(children + i))) != 0) return swin;

   return 0;
}

/*------------------------------------------------------------------------*/

main(int argc, char *argv[])
{
   Widget toplevel;
   Display *dpy;
   Window root, nwin;
   Atom URLATOM, type;
   int format;
   unsigned long nitems, left, result;
   unsigned char *retdata;

   toplevel = XtInitialize(argv[0], "Get_URL", NULL, 0, &argc, argv);
   if (argc > 1)  {      /* single argument is display */
      dpy = XOpenDisplay(argv[1]);
      if (dpy == NULL) {
         fprintf(stderr, "Failure to open display %s:  perhaps access denied?\n",
                argv[1]);
         exit(1);
      }
   }
   else
      dpy = XtDisplay(toplevel);

   root = DefaultRootWindow(dpy);
   nwin = query_window(dpy, root);
   if (nwin > 0) {
      URLATOM = XInternAtom(dpy, "WM_TRANSIENT_FOR", True);
      result = XGetWindowProperty(dpy, nwin, URLATOM, 0, 256, FALSE,
		AnyPropertyType, &type, &format, &nitems, &left, &retdata);

      if ((result == Success) && (nitems > 0)) {
	 nwin = ((long *) retdata)[0];
	 URLATOM = XInternAtom(dpy, "_MOZILLA_URL", True);

	 result = XGetWindowProperty(dpy, nwin, URLATOM, 0, 256, FALSE,
		AnyPropertyType, &type, &format, &nitems, &left, &retdata);
      }
   }

   if (argc > 1) XCloseDisplay(dpy);

   if ((result == Success) && (nitems > 0))
      fprintf(stdout, "%s\n", (char *)retdata);
   else {
      fprintf(stderr, "Didn't get _MOZILLA_URL value:  is Netscape running?\n");
      exit(1);
   }
   exit(0);
}

/*----------------------------------------------------------------------*/
